package org.eclipse.palamedes.gdl.core.model;

import org.eclipse.palamedes.kif.core.ast.KIFTerm;


/**
 * The IMove interface is an adapter interface to wrap reasoner specific 
 * move representations. It stands for a (does ROLE MOVE) relation in GDL. 
 */
public interface IMove {
    /**
     * @return a string representation of the role part of the does relation
     */
    public String getRole();

    /**
     * @return a string representation of the move part of the does relation
     */
    public String getMove();

    public String toString();

    /**
     * @return a term representing the role part of the does relation
     */
    public KIFTerm getRoleTerm();

    /**
     * @return a term representing the move part of the does relation
     */
    public KIFTerm getMoveTerm();
    
}
