package org.eclipse.palamedes.gdl.core.model.utils;

import org.eclipse.palamedes.gdl.core.model.IMove;
import org.eclipse.palamedes.kif.core.ast.KIFTerm;


public class GenericMove<NativeTerm>
	extends TermDelegator<NativeTerm>
	implements IMove {

    protected int hashCode = 0;

    public GenericMove(TermWrapper<NativeTerm> newMove) {
    	super(newMove);
    }

    public String getMove() {
		return getMoveTerm().getInfixNotation();
	}

	public String getRole() {
		return getRoleTerm().getInfixNotation();
	}

	public NativeTerm getNativeMove() {
        return getNativeTerm();
    }

    @Override
    public String toString() {
        return getRole() + " " + getMove();
    }
        
    @Override
    public int hashCode() {
        return (hashCode == 0) ? hashCode = super.hashCode() : hashCode;
    }

	public KIFTerm getRoleTerm() {
		return getTerm().getTerms().get(0);
	}

	public KIFTerm getMoveTerm() {
		return getTerm().getTerms().get(1);
	}
}
