package org.eclipse.palamedes.gdl.core.model.utils;

import org.eclipse.palamedes.kif.core.ast.KIFTerm;

public class TermDelegator<NativeTerm> {
	protected TermWrapper<NativeTerm> termwrapper;
	
	public TermDelegator(TermWrapper<NativeTerm> term){
		this.termwrapper=term;
	}
	
	public KIFTerm getTerm(){
		return termwrapper.getTerm();
	}
	
    public NativeTerm getNativeTerm() {
        return termwrapper.getNativeTerm();
    }

    public String getName() {
        return termwrapper.getName();
    }

    @Override
    public String toString() {
    	return termwrapper.getInfixNotation();
    }

    @Override
    public int hashCode() {
        return termwrapper.hashCode();
    }

    @Override
    public boolean equals(Object obj) {
        return this == obj ||
               (obj instanceof TermDelegator && termwrapper.equals(((TermDelegator<?>)obj).termwrapper));
    }

}
