package org.eclipse.palamedes.gdl.core.model.utils;

import org.eclipse.palamedes.kif.core.ast.KIFTerm;

public abstract class TermWrapper<NativeTerm> {
	
	private String kifNotation=null;
	private String prefixNotation=null;
	private KIFTerm kifTerm=null;
	
	protected NativeTerm nativeTerm;
	
	public TermWrapper(NativeTerm nativeTerm){
		this.nativeTerm=nativeTerm;
	}

	public NativeTerm getNativeTerm() {
		return nativeTerm;
	}
	
	public KIFTerm getTerm(){
		if(kifTerm==null){
			kifTerm=getKIFTerm();
		}
		return kifTerm;
	}
	public abstract KIFTerm getKIFTerm();
	
	public String getName(){
		return getTerm().getName();
	}

	public String getInfixNotation() {
		if(kifNotation==null){
			kifNotation=getTerm().getInfixNotation();
		}
		return kifNotation;
	}

	public String getPrefixNotation() {
		if(prefixNotation==null){
			prefixNotation=getTerm().getPrefixNotation();
		}
		return prefixNotation;
	}

	public boolean equals(Object obj) {
		if (obj instanceof TermWrapper<?>) {
			TermWrapper<?> t = (TermWrapper<?>) obj;
			return getInfixNotation().equals(t.getInfixNotation());
		}else{
			return false;
		}
	}

	public int hashCode() {
		return getInfixNotation().hashCode();
	}

	public String toString(){
		return nativeTerm.toString();
	}

}
