/*
    Copyright (C) 2008 Stephan Schiffel <stephan.schiffel@gmx.de>

    This file is part of Palamedes-IDE.

    Palamedes-IDE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Palamedes-IDE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Palamedes-IDE.  If not, see <http://www.gnu.org/licenses/>.
*/

package org.eclipse.palamedes.gdl.core.resolver.prologprover;

import org.eclipse.palamedes.gdl.core.model.utils.TermWrapper;
import org.eclipse.palamedes.kif.core.ast.AST;
import org.eclipse.palamedes.kif.core.ast.KIFSeq;
import org.eclipse.palamedes.kif.core.ast.KIFTerm;

import com.parctechnologies.eclipse.CompoundTerm;

public class TermAdapter extends TermWrapper<CompoundTerm> {
	
	public TermAdapter(CompoundTerm expr){
		super(expr);
	}

	@Override
	public KIFTerm getKIFTerm() {
		return getKIFTerm(nativeTerm);
	}
	
	public static final KIFTerm getKIFTerm(Object t){
		if(t==null){
			return new AST().newIndVar("var");
		}else if(t instanceof CompoundTerm && ((CompoundTerm)t).arity()==0){
			return new AST().newObjConst(((CompoundTerm)t).functor());
		}else if(t instanceof CompoundTerm){
			CompoundTerm tcomp=(CompoundTerm)t;
			KIFSeq<KIFTerm> args=new KIFSeq<KIFTerm>();
			for(int i=1;i<=tcomp.arity();i++){
				args.add(getKIFTerm(tcomp.arg(i)));
			}
			return new AST().newFunTerm(tcomp.functor(), args);
		}else{
			return new AST().newObjConst(t.toString());
		}
	}
}
